
//16a_start_act2

// All the Act1 -> Act 2 transition stuff in one place.

//DBR 12/11/06
//ARH 12/19/09 - added initial influence calculation

//#include "ginc_companion"
#include "kinc_companion"
#include "x0_i0_stringlib"
#include "ginc_misc"


void AdvanceQuest(string sQuest, int nLevel, object oPCMember, int bOverrideHigher=FALSE)
{
	if ((GetGlobalInt(sQuest)<nLevel)||(bOverrideHigher))
		SetGlobalInt(sQuest,nLevel);
	object oPCF = GetFirstFactionMember(oPCMember,FALSE);
	while (GetIsObjectValid(oPCF))
	{
		AddJournalQuestEntry(sQuest, nLevel, oPCF,TRUE,TRUE,bOverrideHigher);
		oPCF = GetNextFactionMember(oPCMember,FALSE);
	}
}


object GetItemPossessedByFaction(string sTag, object oFaction)
{
	object oFM = GetFirstFactionMember(oFaction,FALSE), oItem;
	while (GetIsObjectValid(oFM))
	{
		oItem = GetItemPossessedBy(oFM,sTag);
		if (GetIsObjectValid(oItem))
			return oItem;
		oFM = GetNextFactionMember(oFaction,FALSE);
	}
	return OBJECT_INVALID;
}

// create shards that were taken in 1623_zee_misc
void PopulateShards(object oPCF)
{
	string sResRefList = GetGlobalString("SHARDS_TAKEN_LIST");
	string sResRef;
	
    struct sStringTokenizer stList = GetStringTokenizer(sResRefList, ",");
    while (HasMoreTokens(stList)) 
	{
        stList = AdvanceToNextToken(stList);
		sResRef = GetNextToken(stList);
		if (!GetIsObjectValid(GetItemPossessedByFaction(sResRef, oPCF)))
			CreateItemOnObject(sResRef, oPCF); 
    }
}


void main()
{
	object oPC = GetPrimaryPlayer();
	if (!GetIsObjectValid(oPC))
		oPC = GetFactionLeader(GetFirstPC());
	if (!GetIsObjectValid(oPC))
		oPC = GetFirstPC();
		
	SetGlobalInt("1600_Flagon_Override",0);	//do not use the 1600 Flagon anymore.
	SetIsRosterMemberSelectable("bishop",TRUE); //Bishop no longer required
	PopulateShards(GetPCSpeaker());
	AdvanceQuest("16_rescue_shandra",110,oPC);
	AddRosterMemberToParty("shandra", oPC);
	SetIsRosterMemberSelectable("shandra", 0);	//Make Shandra required
	SetIsRosterMemberCampaignNPC("shandra", 0);	//let her be visible in party select screens

	object oCreature = GetObjectByTag( "shandra" );	//Reset Shandra's level 
	int nXP = GetPCAverageXP();
	ResetCreatureLevelForXP( oCreature, nXP, 1 );

	// Set initial reaction based on PC Charisma and alignment.  Start with kludgy character check so it doesn't accidentally affect anything but OC
	int nDelta = GetInfluenceAdjustment(oPC, oCreature);
	// This influence change assumes the Original Campaign is being used so no scaling necessary.
	int nInfluence = GetInfluence(oCreature);
	SetInfluence(oCreature,nInfluence+nDelta);
	// INTRUSIVE DEBUG MESSAGE - delete later
	string sMessage = "Influence changed from " + IntToString(nInfluence) + " to " + IntToString(nInfluence+nDelta);
	SendMessageToPC(oPC,sMessage);

	ForceRest( oCreature );
		
	SetRosterNPCPartyLimit(4);		//increase party size
	
	SetGlobalInt("00_bShandraJoined",1);	//Mark Shandra as joined
	SetGlobalInt("17b_ReadyForKarina",3);	//Make Karina dissappear from her spot

	SaveRosterLoadModule("2000_Neverwinter", "wp_2023_start_module");
}