// a_reset_qara.nss
// Reset and rest roster instance of Qara in 10_cs_qara_intro.dlg
// BMA-OEI 6/26/06
// BMA-OEI 8/20/06 -- Replaced GetPCAverageXP(), added ForceRest()
// ARH 12/19/09 - added initial influence

//#include "ginc_companions"
#include "kinc_companion"
#include "ginc_misc"

const string WP_SF_QARA = "10_wp_qara";

void main()
{
	PrettyDebug( "a_reset_qara: Resetting roster instance of Qara..." );

	object oWP = GetWaypointByTag( WP_SF_QARA );
	location lWP = GetLocation( oWP );
	object oQara = SpawnRosterMember( "qara", lWP );
	int nXP = GetPCAverageXP();
	ResetCreatureLevelForXP( oQara, nXP, TRUE );

	// Set initial reaction based on PC Charisma and alignment.  Start with kludgy character check so it doesn't accidentally affect anything but OC
    object oPC = (GetPCSpeaker()==OBJECT_INVALID?OBJECT_SELF:GetPCSpeaker());
	int nDelta = GetInfluenceAdjustment(oPC, oQara);
	// This influence change assumes the Original Campaign is being used so no scaling necessary.
	int nInfluence = GetInfluence(oQara);
	SetInfluence(oQara,nInfluence+nDelta);
	// INTRUSIVE DEBUG MESSAGE - delete later
	string sMessage = "Influence changed from " + IntToString(nInfluence) + " to " + IntToString(nInfluence+nDelta);
	SendMessageToPC(oPC,sMessage);

	ForceRest( oQara );
	//DespawnRosterMember( "qara" );
}