// ga_reset_level( string sCreature, int bUseXPMods )
/*
	Resets creature to PCs average experience level using its current level-up package.
	Creature is also force rested ( full heal, spells refreshed ).

	Parameters:
		string sCreature 	= Tag of creature
		int bUseXPMods 		= If TRUE, XP modifiers will be applied before the experience is awarded
*/
// BMA-OEI 5/08/06
// BMA-OEI 8/09/06 -- Added GetPCAverageXP(), ForceRest()
// ARH 12/14/09 -- added initial influence rating for OC

#include "ginc_debug"
#include "ginc_misc"
//#include "ginc_companion"
#include "kinc_companion"

void main( string sCreature, int bUseXPMods )
{
	object oCreature = GetObjectByTag( sCreature );
	if ( GetIsObjectValid( oCreature ) == FALSE )
	{
		PrettyError( "ga_reset_level: object '" + sCreature + "' is invalid!" );
	}
	
	int nXP = GetPCAverageXP();
	ResetCreatureLevelForXP( oCreature, nXP, bUseXPMods );
	
	// Set initial reaction based on PC Charisma and alignment.  Start with kludgy character check so it doesn't accidentally affect
	// anything but OC.  Qara and Shandra excluded because they have different initialization routines.
	if (sCreature == TAG_KHELGAR || sCreature == TAG_NEESHKA || sCreature == TAG_ELANEE || sCreature == TAG_GROBNAR || sCreature == TAG_CASAVIR || sCreature == TAG_BISHOP || sCreature == TAG_SAND || sCreature == TAG_ZHJAEVE || sCreature == TAG_AMMON)
	{
	    object oPC = (GetPCSpeaker()==OBJECT_INVALID?OBJECT_SELF:GetPCSpeaker());
		int nDelta = GetInfluenceAdjustment(oPC, oCreature);
		// This influence change assumes the Original Campaign is being used so no scaling necessary.
		int nInfluence = GetInfluence(oCreature);
		SetInfluence(oCreature,nInfluence+nDelta);
		// INTRUSIVE DEBUG MESSAGE - delete later
		string sMessage = "Influence changed from " + IntToString(nInfluence) + " to " + IntToString(nInfluence+nDelta);
		SendMessageToPC(oPC,sMessage);
	}	
	ForceRest( oCreature );
}